/************************************************************************  
*   PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq                         *
*   PROJETO: Desenvolvimento de um simulador de algoritmos qunticos    *
*            utilizando a computao convencional                       *
* --------------------------------------------------------------------- *
*      Bolsista: Anderson de Rezende Rocha - DCC/UFLA                   *
*                   # undersun@comp.ufla.br         (1)                 *
*                   # phiberoptic_br@yahoo.com.br   (2)                 *
* --------------------------------------------------------------------- *
*  Orientadores: Antnio Maria Pereira de Resende                       *
*                   # tonio@comp.ufla.br                                *
*                Antonio Tavares Costa Junior                           *
*                   # antc@stout.ufla.br                                *
*************************************************************************/

import java.util.Vector;
import java.io.*;

public class BaseFourier 
{
	Vector vetorNumeros;
	FileInputStream entrada;
	File arqEntrada;
	
	public BaseFourier(String nomeArquivo) throws IOException, FileNotFoundException
	{
		vetorNumeros = new Vector();

		// Referncia para o arquivo
		arqEntrada	= new File(nomeArquivo);

		// Referncia para o fluxo de entrada
		entrada	= new FileInputStream(arqEntrada);

		int tokenInt;
		char tokenChar;
		double numero;
		String s = "";

		while ((tokenInt = entrada.read()) != -1)
		{
			tokenChar = (char)tokenInt;

			if (tokenChar != ' ' && tokenChar != '\t' && tokenChar != '\n')
				s += tokenChar;
			else
			{
				try
				{
					numero = Double.parseDouble(s);	
					vetorNumeros.addElement(s);
				}
				catch (Exception e) {}

				s = "";
			}
		}
        entrada.close();

		vetorNumeros = classificarVetor(vetorNumeros);
	}

	public Vector getSequenciaNumeros()
	{
		return vetorNumeros;
	}

	private Vector classificarVetor(Vector v)
	{
		Vector retorno = new Vector();
		Complexos c;
		double real, imaginaria;

		for (int i = 0; i < v.size(); i+= 2)
		{
			real = Double.parseDouble((String)v.elementAt(i));
			imaginaria = Double.parseDouble((String)v.elementAt(i+1));

			c = new Complexos(real, imaginaria);
			retorno.addElement(c);
		}

		return retorno;
	}
}

