/************************************************************************  
*   PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq                         *
*   PROJETO: Desenvolvimento de um simulador de algoritmos qunticos    *
*            utilizando a computao convencional                       *
* --------------------------------------------------------------------- *
*      Bolsista: Anderson de Rezende Rocha - DCC/UFLA                   *
*                   # undersun@comp.ufla.br         (1)                 *
*                   # phiberoptic_br@yahoo.com.br   (2)                 *
* --------------------------------------------------------------------- *
*  Orientadores: Antnio Maria Pereira de Resende                       *
*                   # tonio@comp.ufla.br                                *
*                Antonio Tavares Costa Junior                           *
*                   # antc@stout.ufla.br                                *
*************************************************************************/

import java.text.DecimalFormat;

public class FourierTask 
{
    private static int		status;
	private static String	mensagem;
	private int				tamanhoTarefa;
	private	Fourier			algoritmo;
	private Complexos	    sequencia[];
	
	public static void setStatus(double d)
	{
		status = (int)d;
	}

	public static void setMensagem(String msg)
	{
		mensagem += msg;
	}

	public String getMensagem()
	{
		return mensagem;
	}
	
	public FourierTask() 
	{
        tamanhoTarefa = 100;
		mensagem = "";
		status = 0;
    }

	public void setSequencia(Complexos seq[])
	{
		sequencia = seq;
	}

	public Complexos[] getSequencia()
	{
		return algoritmo.getResultados();
	}

    void go() 
	{
        tamanhoTarefa = 100;
		mensagem = "";
		status = 0;

        final SwingWorker worker = new SwingWorker() 
		{
            public Object construct() 
			{
                return new ActualTask();
            }
        };
        
		worker.start();
    }

    int getTamanhoTarefa() 
	{
        return tamanhoTarefa;
    }

    int getStatus() 
	{
        return status;
    }

    void stop() 
	{
        status = tamanhoTarefa;
    }

	void pause()
	{
		try
		{
			algoritmo.wait();
		}
		catch (Exception e) {}
	}

	void resume()
	{
		try
		{
			algoritmo.notify();
		}
		catch (Exception e) {}
	}

    boolean done() 
	{
        if (status >= tamanhoTarefa)
            return true;
        else
            return false;
    }

	class ActualTask 
	{
		ActualTask () 
		{
			algoritmo = new Fourier(sequencia);

			while (status < tamanhoTarefa) 
			{
				algoritmo.run();
			
				if (status > tamanhoTarefa) 
				{
	                status = tamanhoTarefa;
					try
					{
						algoritmo.wait();	
					}
					catch (Exception e) {}					
				}
            }
        }
    }
}