/************************************************************************  
*   PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq                         *
*   PROJETO: Desenvolvimento de um simulador de algoritmos qunticos    *
*            utilizando a computao convencional                       *
* --------------------------------------------------------------------- *
*      Bolsista: Anderson de Rezende Rocha - DCC/UFLA                   *
*                   # undersun@comp.ufla.br         (1)                 *
*                   # phiberoptic_br@yahoo.com.br   (2)                 *
* --------------------------------------------------------------------- *
*  Orientadores: Antnio Maria Pereira de Resende                       *
*                   # tonio@comp.ufla.br                                *
*                Antonio Tavares Costa Junior                           *
*                   # antc@stout.ufla.br                                *
*************************************************************************/

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.net.URL;
import java.io.IOException;

public class FrameSobre extends JInternalFrame 
{
	protected static final int	xOffset = 30, yOffset = 30;
	protected static int		contadorDeInstancias = 0;

	protected Container			c;
	protected Font				fonteArial10;
	protected ImageIcon			icones[];
	protected JButton			btFechar;
	protected JTabbedPane		tabPainel;
	protected JPanel			painelDesenvolvimento;
	protected JPanel			painelAgradecimentos;
	protected JScrollPane		scrollDesenvolvedores;
	protected JScrollPane		scrollAgradecimentos;
	
	public FrameSobre() 
	{
		super("Sobre o Desenvolvimento #" + (++contadorDeInstancias), 
              false,	// manipulvel
              true,		// fechvel
              false,	// maximizvel
              true);	// iconificvel

		fonteArial10			= new Font("Arial", Font.PLAIN, 10);
		scrollDesenvolvedores	= new JScrollPane(criarEditorPane("Sobre.html"));
		scrollAgradecimentos	= new JScrollPane(criarEditorPane("Agradecimentos.html"));
		tabPainel				= new JTabbedPane();
		painelDesenvolvimento	= new JPanel();
		painelAgradecimentos	= new JPanel();
		icones					= new ImageIcon[3];

		icones[0] = new ImageIcon(this.getClass().getResource("pics/tabDesenvolvedores.png"));
		icones[1] = new ImageIcon(this.getClass().getResource("pics/tabAgradecimentos.png"));

		painelDesenvolvimento.setLayout(new BorderLayout());
		painelAgradecimentos.setLayout(new BorderLayout());
		
		scrollDesenvolvedores.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		scrollDesenvolvedores.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scrollDesenvolvedores.setBorder(BorderFactory.createEmptyBorder());

		scrollAgradecimentos.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		scrollAgradecimentos.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scrollAgradecimentos.setBorder(BorderFactory.createEmptyBorder());
		
		painelDesenvolvimento.add(scrollDesenvolvedores, BorderLayout.CENTER);
		painelAgradecimentos.add(scrollAgradecimentos, BorderLayout.CENTER);
		painelDesenvolvimento.setBackground(Color.white);
		painelDesenvolvimento.setBorder(BorderFactory.createEmptyBorder());
		painelAgradecimentos.setBackground(Color.white);
		painelAgradecimentos.setBorder(BorderFactory.createEmptyBorder());

		tabPainel.setBorder(BorderFactory.createEmptyBorder());
		tabPainel.setFont(fonteArial10);

		tabPainel.addTab("OS DESENVOLVEDORES", icones[0], painelDesenvolvimento, 
						 "Sobre as pessoas que desenvolveram o SAQua");
		tabPainel.addTab("AGRADECIMENTOS", icones[1], painelAgradecimentos, 
						 "Agradecimentos queles que contriburam ao SAQua");

		setSize(640,480);
        setLocation(xOffset*contadorDeInstancias, yOffset*contadorDeInstancias);
		setOpaque(false);
		setBackground(Color.white);

		c = getContentPane();
		c.setLayout(new BorderLayout());
		c.add(tabPainel, BorderLayout.CENTER);
	}

	private JEditorPane criarEditorPane(String pagina) 
	{
		JEditorPane editorPane = new JEditorPane();
        editorPane.setEditable(false);
        
		String endereco = null;
    
		try 
		{
			endereco = "file:"
						+ System.getProperty("user.dir")
						+ System.getProperty("file.separator")
						+ pagina;
            
			URL urlBase = new URL(endereco);
            mostrarURL(urlBase, editorPane);
        } 
		catch (Exception e) 
		{
			try
			{
				URL urlBase = new URL(
				"file:C:/Arquivos/ComputacaoQuantica/SimuladorQuantico/vs2.0/" + pagina); 
		        mostrarURL(urlBase, editorPane);	
			}
			catch (Exception exc)
			{
				System.out.println("ERRO: URL no encontrada");
			}

			System.err.println("ERRO: Nao foi possivel criar URL " + endereco);
        }

        editorPane.setBorder(BorderFactory.createEmptyBorder());

		return editorPane;
    }

    private void mostrarURL(URL url, JEditorPane ep) 
	{
        try 
		{
            ep.setPage(url);
        } 
		catch (IOException e) 
		{
            System.err.println("ERRO: URL invalida " + url);
        }
    }
}