/************************************************************************  
*   PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq                         *
*   PROJETO: Desenvolvimento de um simulador de algoritmos qunticos    *
*            utilizando a computao convencional                       *
* --------------------------------------------------------------------- *
*      Bolsista: Anderson de Rezende Rocha - DCC/UFLA                   *
*                   # undersun@comp.ufla.br         (1)                 *
*                   # phiberoptic_br@yahoo.com.br   (2)                 *
* --------------------------------------------------------------------- *
*  Orientadores: Antnio Maria Pereira de Resende                       *
*                   # tonio@comp.ufla.br                                *
*                Antonio Tavares Costa Junior                           *
*                   # antc@stout.ufla.br                                *
*************************************************************************/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class HandlerBotoes implements ActionListener
{
   Component	componentePai;
   String		entrada;
   FrameShor	gui			= null;
   FrameSobre   guiSobre	= null;
   int			opcao;

   // Ponteiros para os componentes pai
   HandlerBotoes(Component cpt, FrameShor ca)
   {
      componentePai = cpt;
      gui			= ca;
	  entrada		= "";
	  opcao			= 1;
   }

   HandlerBotoes(Component cpt, FrameSobre ca)
   {
	  componentePai	 = cpt;
      guiSobre		 = ca;
	  entrada		 = "";
	  opcao			 = 2;
   }

	// Identificao do tipo de ao impetrada pelo usurio
	public void actionPerformed(ActionEvent e)
	{
		switch (opcao)
		{
			case 1:
				if (e.getSource() == gui.btFechar)
				{
					gui.dispose();
				}
				else if (e.getSource() ==  gui.campoNumero)
				{
					int numero = 21;
					try
					{
						numero = Integer.parseInt(e.getActionCommand());
						
						if (numero >= 200)
						{
							JOptionPane.showMessageDialog(componentePai, "Nmero informado muito grande. Escolhido 21", 
													 "Aviso", JOptionPane.WARNING_MESSAGE);
							ShorTask.NUMERO = 21;
						}
						else
							ShorTask.NUMERO =  numero;
			
						gui.campoNumero.setEnabled(false);
						gui.btFatorar.setEnabled(true);
					}
					catch (NumberFormatException nfe)
					{
						JOptionPane.showMessageDialog(componentePai, "Nmero informado invlido. Escolhido 21", 
													 "Aviso", JOptionPane.WARNING_MESSAGE);
						gui.campoNumero.setEnabled(false);
						ShorTask.NUMERO = numero;
						gui.btFatorar.setEnabled(true);
					}
				}
				else if (e.getSource() == gui.btFatorar)
				{
					gui.timer.start();
					gui.tarefa.go();
					gui.tarefa.setMensagem("");
					gui.btFatorar.setEnabled(false);
					gui.btPausar.setEnabled(true);
				}
				else if (e.getSource() == gui.btPausar)
				{
					if ((e.getActionCommand()).equals("Pausar"))
					{
						gui.timer.stop();
						gui.tarefa.pause();
						gui.btPausar.setText("Retornar");
						gui.btPausar.setMnemonic('R');
						gui.btPausar.setToolTipText("Retorna  execuo da fatorao");
					}
					else
					{
						gui.timer.start();
						gui.tarefa.resume();
						gui.btPausar.setText("Pausar");
						gui.btPausar.setMnemonic('P');
						gui.btPausar.setToolTipText("Pausa a execuo da fatorao");
					}
				}
				else if (e.getSource() == gui.comboEstados)
				{
					int opcao = gui.comboEstados.getSelectedIndex();

					for (int i = 0; i < 5; i++)
						gui.painel[i].setVisible(false);

					gui.painel[opcao].setVisible(true);
				}
				break;
			case 2:
				if (e.getSource() == guiSobre.btFechar)
				{
					guiSobre.dispose();
				}
				break;
			default:
				break;
		}
	}
}