/************************************************************************  
*   PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq                         *
*   PROJETO: Desenvolvimento de um simulador de algoritmos qunticos    *
*            utilizando a computao convencional                       *
* --------------------------------------------------------------------- *
*      Bolsista: Anderson de Rezende Rocha - DCC/UFLA                   *
*                   # undersun@comp.ufla.br         (1)                 *
*                   # phiberoptic_br@yahoo.com.br   (2)                 *
* --------------------------------------------------------------------- *
*  Orientadores: Antnio Maria Pereira de Resende                       *
*                   # tonio@comp.ufla.br                                *
*                Antonio Tavares Costa Junior                           *
*                   # antc@stout.ufla.br                                *
*************************************************************************/

import java.text.DecimalFormat;

public class ShorTask 
{
    private static int		status;
	private static String	mensagem;
	private static String	estadoReg1;
	private static String   estadoReg2;
	private static String	estadoProb1;
	private static String	estadoProb2;
	private static String	estadoModulo;
    protected static int	NUMERO;
	private int				tamanhoTarefa;
	private	Shor			algoritmo;
	
	public static void setEstadosObjeto(Object obj, String acao, int id)
	{
		Complexos c[];
		DecimalFormat numero = new DecimalFormat("0.00000000");
		Registradores r;
		int num[];
		
		switch (id)
		{
			case 1:
				r = (Registradores)obj;
				c = r.getEstados();
				estadoReg1 += acao + "\n";

				for (int i = 0; i < r.tamanho(); i++)
				{
					if (i <= 9)
						estadoReg1 += "  [" + i + "]  ";
					else 
						estadoReg1 += "[" + i + "]  ";

					estadoReg1 += numero.format(c[i].getReal()) + " , " 
							   + numero.format(c[i].getImaginaria())
							   + "i\n";
				}
				estadoReg1 += "\n";
				break;
			case 2:
				r = (Registradores)obj;
				c = r.getEstados();
				estadoReg2 += acao + "\n";

				for (int i = 0; i < r.tamanho(); i++)
				{
					if (i <= 9)
						estadoReg2 += "  [" + i + "]  ";
					else 
						estadoReg2 += "[" + i + "]  ";

					estadoReg2 += numero.format(c[i].getReal()) + " , " 
							   + numero.format(c[i].getImaginaria())
							   + "i\n";
				}
				estadoReg2 += "\n";
				break;
			case 3:
				c = (Complexos[])obj;
				estadoProb1 += acao + "\n";

				for (int i = 0; i < c.length; i++)
				{
					if (i <= 9)
						estadoProb1 += "  [" + i + "]  ";
					else 
						estadoProb1 += "[" + i + "]  ";
					
					estadoProb1 += numero.format(c[i].getReal()) + " , " 
							    + numero.format(c[i].getImaginaria())
							    + "i\n";
				}
				estadoProb1 += "\n";				
				break;
			case 4:
				c = (Complexos[])obj;
				estadoProb2 += acao + "\n";

				for (int i = 0; i < c.length; i++)
				{
					if (i <= 9)
						estadoProb2 += "  [" + i + "]  ";
					else 
						estadoProb2 += "[" + i + "]  ";
					
					estadoProb2 += numero.format(c[i].getReal()) + " , " 
							    + numero.format(c[i].getImaginaria())
							    + "i\n";
				}
				estadoProb2 += "\n";	
				break;
			case 5:
				num = (int[])obj;
				estadoModulo += acao + "\n";

				for (int i = 0; i < num.length; i++)
				{
					if (i <= 9)
						estadoModulo += "  [" + i + "]  ";
					else 
						estadoModulo += "[" + i + "]  ";
					
					estadoModulo += numero.format(num[i]) + "\n";
				}
				estadoModulo += "\n";
				break;
			default:
				break;
		}
	}

	public String getEstadosObjeto(int id)
	{
		String retorno = "";

		switch (id)
		{
			case 1:
				retorno = estadoReg1;
				break;
			case 2:
				retorno = estadoReg2;
				break;
			case 3:
				retorno = estadoProb1;
				break;
			case 4:
				retorno = estadoProb2;
				break;
			case 5:
				retorno = estadoModulo;
				break;
			default:
				break;
		}
		return retorno;
	}

	public static void setStatus(double d)
	{
		status = (int)d;
	}

	public static void setMensagem(String msg)
	{
		mensagem += msg;
	}

	public String getMensagem()
	{
		return mensagem;
	}
	
	ShorTask() 
	{
        tamanhoTarefa = 100;
		mensagem = "";
		estadoReg1 = "";
		estadoReg2 = "";
		estadoProb1 = "";
		estadoProb2 = "";
		estadoModulo = "";
		status = 0;
		NUMERO = 0;
    }

    void go() 
	{
        tamanhoTarefa = 100;
		mensagem = "";
		estadoReg1 = "";
		estadoReg2 = "";
		estadoProb1 = "";
		estadoProb2 = "";
		estadoModulo = "";
		status = 0;

        final SwingWorker worker = new SwingWorker() 
		{
            public Object construct() 
			{
                return new ActualTask();
            }
        };
        
		worker.start();
    }

    int getTamanhoTarefa() 
	{
        return tamanhoTarefa;
    }

    int getStatus() 
	{
        return status;
    }

    void stop() 
	{
        status = tamanhoTarefa;
    }

	void pause()
	{
		try
		{
			algoritmo.wait();
		}
		catch (Exception e) {}
	}

	void resume()
	{
		try
		{
			algoritmo.notify();
		}
		catch (Exception e) {}
	}

    boolean done() 
	{
        if (status >= tamanhoTarefa)
            return true;
        else
            return false;
    }

	class ActualTask 
	{
		ActualTask () 
		{
			algoritmo = new Shor(NUMERO);

            while (status < tamanhoTarefa) 
			{
				algoritmo.run();
			
				if (status > tamanhoTarefa) 
				{
	                status = tamanhoTarefa;
					try
					{
						algoritmo.wait();	
					}
					catch (Exception e) {}					
				}
            }
        }
    }
}